OpenVDB: GridMetaData Class Reference

OpenVDB 13.0.0

Loading...
Searching...
No Matches
GridMetaData Class Reference

This is a convenient class that allows for access to grid meta-data that are independent of the value type of a grid. That is, this class can be used to get information about a grid without actually knowing its ValueType. More...

`#include <nanovdb/NanoVDB.h>`

## Public Member Functions
template<typename T>
| GridMetaData (const NanoGrid< T > &grid)
| GridMetaData (const GridData *gridData)
GridMetaData & | operator= (const GridMetaData &)=default
__hostdev__ bool | safeCast () const
| return true if the RootData follows right after the TreeData. If so, this implies that it's safe to cast the grid from which this instance was constructed to a GridMetaData
__hostdev__ bool | isValid () const
__hostdev__ const GridType & | gridType () const
__hostdev__ const GridClass & | gridClass () const
__hostdev__ bool | isLevelSet () const
__hostdev__ bool | isFogVolume () const
__hostdev__ bool | isStaggered () const
__hostdev__ bool | isPointIndex () const
__hostdev__ bool | isGridIndex () const
__hostdev__ bool | isPointData () const
__hostdev__ bool | isMask () const
__hostdev__ bool | isUnknown () const
__hostdev__ bool | hasMinMax () const
__hostdev__ bool | hasBBox () const
__hostdev__ bool | hasLongGridName () const
__hostdev__ bool | hasAverage () const
__hostdev__ bool | hasStdDeviation () const
__hostdev__ bool | isBreadthFirst () const
__hostdev__ uint64_t | gridSize () const
__hostdev__ uint32_t | gridIndex () const
__hostdev__ uint32_t | gridCount () const
__hostdev__ const char * | shortGridName () const
__hostdev__ const Map & | map () const
__hostdev__ const Vec3dBBox & | worldBBox () const
__hostdev__ const CoordBBox & | indexBBox () const
__hostdev__ Vec3d | voxelSize () const
__hostdev__ uint32_t | blindDataCount () const
__hostdev__ uint64_t | activeVoxelCount () const
__hostdev__ const uint32_t & | activeTileCount (uint32_t level) const
__hostdev__ uint32_t | nodeCount (uint32_t level) const
__hostdev__ const Checksum & | checksum () const
__hostdev__ uint32_t | rootTableSize () const
__hostdev__ bool | isEmpty () const
__hostdev__ Version | version () const

## Static Public Member Functions
static __hostdev__ bool | safeCast (const GridData *gridData)
| return true if it is safe to cast the grid to a pointer of type GridMetaData, i.e. construction can be avoided.
template<typename T>
static __hostdev__ bool | safeCast (const NanoGrid< T > &grid)
| return true if it is safe to cast the grid to a pointer of type GridMetaData, i.e. construction can be avoided.

## Detailed Description

This is a convenient class that allows for access to grid meta-data that are independent of the value type of a grid. That is, this class can be used to get information about a grid without actually knowing its ValueType.

## Constructor & Destructor Documentation

## ◆ GridMetaData() [1/2]

template<typename T>

GridMetaData | ( | const NanoGrid< T > & | grid | ) |
| inline

## ◆ GridMetaData() [2/2]

GridMetaData | ( | const GridData * | gridData | ) |
| inline

## Member Function Documentation

## ◆ activeTileCount()

__hostdev__ const uint32_t & activeTileCount | ( | uint32_t | level | ) | const
| inline

## ◆ activeVoxelCount()

__hostdev__ uint64_t activeVoxelCount | ( |  | ) | const
| inline

## ◆ blindDataCount()

__hostdev__ uint32_t blindDataCount | ( |  | ) | const
| inline

## ◆ checksum()

__hostdev__ const Checksum & checksum | ( |  | ) | const
| inline

## ◆ gridClass()

__hostdev__ const GridClass & gridClass | ( |  | ) | const
| inline

## ◆ gridCount()

__hostdev__ uint32_t gridCount | ( |  | ) | const
| inline

## ◆ gridIndex()

__hostdev__ uint32_t gridIndex | ( |  | ) | const
| inline

## ◆ gridSize()

__hostdev__ uint64_t gridSize | ( |  | ) | const
| inline

## ◆ gridType()

__hostdev__ const GridType & gridType | ( |  | ) | const
| inline

## ◆ hasAverage()

__hostdev__ bool hasAverage | ( |  | ) | const
| inline

## ◆ hasBBox()

__hostdev__ bool hasBBox | ( |  | ) | const
| inline

## ◆ hasLongGridName()

__hostdev__ bool hasLongGridName | ( |  | ) | const
| inline

## ◆ hasMinMax()

__hostdev__ bool hasMinMax | ( |  | ) | const
| inline

## ◆ hasStdDeviation()

__hostdev__ bool hasStdDeviation | ( |  | ) | const
| inline

## ◆ indexBBox()

__hostdev__ const CoordBBox & indexBBox | ( |  | ) | const
| inline

## ◆ isBreadthFirst()

__hostdev__ bool isBreadthFirst | ( |  | ) | const
| inline

## ◆ isEmpty()

__hostdev__ bool isEmpty | ( |  | ) | const
| inline

## ◆ isFogVolume()

__hostdev__ bool isFogVolume | ( |  | ) | const
| inline

## ◆ isGridIndex()

__hostdev__ bool isGridIndex | ( |  | ) | const
| inline

## ◆ isLevelSet()

__hostdev__ bool isLevelSet | ( |  | ) | const
| inline

## ◆ isMask()

__hostdev__ bool isMask | ( |  | ) | const
| inline

## ◆ isPointData()

__hostdev__ bool isPointData | ( |  | ) | const
| inline

## ◆ isPointIndex()

__hostdev__ bool isPointIndex | ( |  | ) | const
| inline

## ◆ isStaggered()

__hostdev__ bool isStaggered | ( |  | ) | const
| inline

## ◆ isUnknown()

__hostdev__ bool isUnknown | ( |  | ) | const
| inline

## ◆ isValid()

__hostdev__ bool isValid | ( |  | ) | const
| inline

## ◆ map()

__hostdev__ const Map & map | ( |  | ) | const
| inline

## ◆ nodeCount()

__hostdev__ uint32_t nodeCount | ( | uint32_t | level | ) | const
| inline

## ◆ operator=()

GridMetaData & operator= | ( | const GridMetaData & |  | ) |
| default

## ◆ rootTableSize()

__hostdev__ uint32_t rootTableSize | ( |  | ) | const
| inline

## ◆ safeCast() [1/3]

__hostdev__ bool safeCast | ( |  | ) | const
| inline

return true if the RootData follows right after the TreeData. If so, this implies that it's safe to cast the grid from which this instance was constructed to a GridMetaData

## ◆ safeCast() [2/3]

__hostdev__ bool safeCast | ( | const GridData * | gridData | ) |
| inlinestatic

return true if it is safe to cast the grid to a pointer of type GridMetaData, i.e. construction can be avoided.

## ◆ safeCast() [3/3]

template<typename T>

__hostdev__ bool safeCast | ( | const NanoGrid< T > & | grid | ) |
| inlinestatic

return true if it is safe to cast the grid to a pointer of type GridMetaData, i.e. construction can be avoided.

## ◆ shortGridName()

__hostdev__ const char * shortGridName | ( |  | ) | const
| inline

## ◆ version()

__hostdev__ Version version | ( |  | ) | const
| inline

## ◆ voxelSize()

__hostdev__ Vec3d voxelSize | ( |  | ) | const
| inline

## ◆ worldBBox()

__hostdev__ const Vec3dBBox & worldBBox | ( |  | ) | const
| inline